#import <Cocoa/Cocoa.h>
#import "main.h"
#import "WordTableDataSource.h"

@interface MainController : NSObject
{
	struct bw_block * blocks;
	int block_cnt;
	
	WordTableDataSource			* wtds;
	
	NSMutableDictionary			* words;
	NSMutableArray					* word_parts;
	
	NSColor									* txtColor;
	NSMutableArray					* charList;
	
	IBOutlet NSButton				* loadBtn;				// load the word list
	IBOutlet NSTextField		* fileTxt;				// 
	IBOutlet NSTextField		* minWordLen;			// 
	IBOutlet NSTextField		* maxWordLen;			// 
	IBOutlet NSTextField		* wordCount;			// 
	IBOutlet NSProgressIndicator * wordLoadPi;		// word load progress indicator
	
	IBOutlet NSTextField		* matchCount;			// 
	IBOutlet NSTextField		* timeTxt;				// 
	IBOutlet NSTableView		* resultTbl;			// 
	
	IBOutlet NSButton				* searchBtn;			// 
	
	IBOutlet NSTextField * char01;
	IBOutlet NSTextField * char02;
	IBOutlet NSTextField * char03;
	IBOutlet NSTextField * char04;
	IBOutlet NSTextField * char05;
	IBOutlet NSTextField * char06;
	IBOutlet NSTextField * char07;
	IBOutlet NSTextField * char08;
	IBOutlet NSTextField * char09;
	IBOutlet NSTextField * char10;
	IBOutlet NSTextField * char11;
	IBOutlet NSTextField * char12;
	IBOutlet NSTextField * char13;
	IBOutlet NSTextField * char14;
	IBOutlet NSTextField * char15;
	IBOutlet NSTextField * char16;
	IBOutlet NSTextField * char17;
	IBOutlet NSTextField * char18;
	IBOutlet NSTextField * char19;
	IBOutlet NSTextField * char20;
	IBOutlet NSTextField * char21;
	IBOutlet NSTextField * char22;
	IBOutlet NSTextField * char23;
	IBOutlet NSTextField * char24;
	IBOutlet NSTextField * char25;
	IBOutlet NSTextField * char26;
	IBOutlet NSTextField * char27;
	IBOutlet NSTextField * char28;
	IBOutlet NSTextField * char29;
	IBOutlet NSTextField * char30;
	IBOutlet NSTextField * char31;
	IBOutlet NSTextField * char32;
	IBOutlet NSTextField * char33;
	IBOutlet NSTextField * char34;
	IBOutlet NSTextField * char35;
	IBOutlet NSTextField * char36;
	IBOutlet NSTextField * char37;
	IBOutlet NSTextField * char38;
	IBOutlet NSTextField * char39;
	IBOutlet NSTextField * char40;
	IBOutlet NSTextField * char41;
	IBOutlet NSTextField * char42;
	IBOutlet NSTextField * char43;
	IBOutlet NSTextField * char44;
	IBOutlet NSTextField * char45;
	IBOutlet NSTextField * char46;
	IBOutlet NSTextField * char47;
	IBOutlet NSTextField * char48;
	IBOutlet NSTextField * char49;
	IBOutlet NSTextField * char50;
	IBOutlet NSTextField * char51;
	IBOutlet NSTextField * char52;
	
}

- (IBAction)actionChoose:(id)sender;
- (IBAction)actionStart:(id)sender;
- (IBAction)actionStop:(id)sender;

- (void)search;
- (void)showWordMatch:(char *)word path:(struct bw_block **)path;

- (void)readGrid;
- (void)initWords:(NSString *)file;
- (void)initBlocks:(NSArray *)config;
- (void)clearChars;
- (void)toggleChars:(BOOL)onOff;

@end
